<?php
/*                                                                                                                                                       
  mememe                                     ememem
    \ememememem                       ememememem/ 
     ememememememem               ememememememem  
      emememememememe           emememememememe   
         \memememememem       ememememememe/      
         emememememememe     emememememememe     
                 emememem   ememememe              
                     ememe ememe                   
                       emememe                     
                         eme
                          e  
                             
	^^ Title : Select Category Pro in Tabs			 
	^^ Create : 2021-02-19
	^^ For PS version 1.6, 1.7
	   @author : EAGLEMEDIA.de <eagle@eaglemedia.de>
	   @copyright : EAGLEMEDIA.de	   
	   @license : See appended file licence.txt
	   @link : http://eaglemedia.de
*/ 

	# Reports for either E_ERROR | E_WARNING | 
	# E_NOTICE | Any Error
	#
	#ini_set("display_startup_errors", 1);
	#ini_set("display_errors", 1);
	#error_reporting(E_ALL);

if (!defined('_CAN_LOAD_FILES_'))
	exit;

class SelectCategoryPro2 extends Module
{
	protected static $cache_products;
	
	private $_postErrors = array();
	
    public function __construct()
	{
		$this->name = 'selectcategorypro2';
        $this->tab = 'front_office_features';
		$this->version = '1.6.2';
		$this->author = 'eaglemedia.de';
		$this->need_instance = 0;
		$this->bootstrap = true;
        
		parent::__construct();	
		
		$this->displayName = $this->l('Select Category Pro (2) in Tabs');
		$this->description = $this->l('Selected products from a category on the product, shopping cart, checkout and start page, optionally with freely selectable products.');
		$this->ps_versions_compliancy = array('min' => '1.6', 'max' => _PS_VERSION_);
	}
	
    public function install()
	{
	    $this->_clearCache('*');
	    Configuration::updateValue('SELECTCATPRO2_ROTATION', 1);
		
		if (!parent::install()	
            // hooks for v1.6.x
			OR !$this->registerHook('displayHeader')
			OR !$this->registerHook('addproduct')
			OR !$this->registerHook('updateproduct')
			OR !$this->registerHook('deleteproduct')
			OR !$this->registerHook('categoryUpdate')				
			OR !$this->registerHook('displayHomeTab')
			OR !$this->registerHook('displayHomeTabContent') 
            OR !$this->registerHook('displayFooterProduct')
            
            // hooks for v1.7.x
			OR !$this->registerHook('addproduct')
			OR !$this->registerHook('updateproduct')
			OR !$this->registerHook('deleteproduct')
			OR !$this->registerHook('categoryUpdate')
			OR !$this->registerHook('displayHome')
			OR !$this->registerHook('displayOrderConfirmation2')
			OR !$this->registerHook('displayCrossSellingShoppingCart')
			OR !$this->registerHook('actionAdminGroupsControllerSaveAfter') 
            OR !$this->registerHook('displayReassurance')
            
			OR !$this->installFixtures()
			OR !$this->disableDevice(Context::DEVICE_MOBILE))
			return false;
		return true;
	}
	
	protected function installFixtures()
	{
		$languages = Language::getLanguages(false);
		foreach ($languages as $lang)
			$this->installFixture((int)$lang['id_lang']);

		return true;
	}
	
	protected function installFixture($id_lang)
	{		
		$values['SELECTCATPRO2_NPRODUCTS'][(int)$id_lang] = '6';
		$values['SELECTCATPRO2_ID'][(int)$id_lang] = '4';
		$values['SELECTCATPRO2_TITLE'][(int)$id_lang] = 'Tab by Eaglemedia';
		
		Configuration::updateValue('SELECTCATPRO2_NPRODUCTS', $values['SELECTCATPRO2_NPRODUCTS']);
		Configuration::updateValue('SELECTCATPRO2_ID', $values['SELECTCATPRO2_ID']);
		Configuration::updateValue('SELECTCATPRO2_TITLE', $values['SELECTCATPRO2_TITLE']);
	}

    public function uninstall()	
	{	
	    $this->_clearCache('*');
	    
		if (!parent::uninstall()
		    OR !Configuration::deleteByName('SELECTCATPRO2_NPRODUCTS')
			OR !Configuration::deleteByName('SELECTCATPRO2_ID')
			OR !Configuration::deleteByName('SELECTCATPRO2_TITLE')
			OR !Configuration::deleteByName('SELECTCATPRO2_ROTATION')
			OR !Configuration::deleteByName('SELECTCATPRO2_IDS'))
			return false;
		return true;
	}

	public function postProcess()
	{		
        if (Tools::isSubmit('submitSelectPro'))
		{			
			$languages = Language::getLanguages(false);
			$values = array();			
			foreach ($languages as $lang)
			{		
				$values['SELECTCATPRO2_NPRODUCTS'][$lang['id_lang']] = Tools::getValue('SELECTCATPRO2_NPRODUCTS_'.$lang['id_lang']);
				$values['SELECTCATPRO2_ID'][$lang['id_lang']] = Tools::getValue('SELECTCATPRO2_ID_'.$lang['id_lang']);
				$values['SELECTCATPRO2_TITLE'][$lang['id_lang']] = Tools::getValue('SELECTCATPRO2_TITLE_'.$lang['id_lang']);				
			}				
    	
			$nbs_products = $values['SELECTCATPRO2_NPRODUCTS'];				
			$ids_selected = $values['SELECTCATPRO2_ID'];		
			$titles = $values['SELECTCATPRO2_TITLE'];
			$rotation = Tools::getValue('SELECTCATPRO2_ROTATION');
			$idS_selected = Tools::getValue('SELECTCATPRO2_IDS');	

            if ( !trim($idS_selected) )
            {
                foreach ($nbs_products as $nbs_product)
                {	
                    if ($nbs_product <= 0  OR !Validate::isInt($nbs_product))
                       $this->_postErrors[] = $this->l('Number of product is invalid in language');
                }			
                foreach ($ids_selected as $ids_select)
                {	
                    if ($ids_select <= 0  OR !Validate::isInt($ids_select))
                       $this->_postErrors[] = $this->l('Number of category is invalid in language');
                } 
                foreach ($titles as $title)
                {	
                    if (empty($title))
                       $this->_postErrors[] = $this->l('Enter a headline for the Box in language');
                    elseif (strlen($title) > 27)
                       $this->_postErrors[] = $this->l('Error title, are allowed max 27 characters in language').' - '.$title;	
                }	
            }
            
   		    #print_r($this->_postErrors);
			if (isset($this->_postErrors) AND sizeof($this->_postErrors))
			    return $this->displayError(implode('<br />', $this->_postErrors));
			else	
			{ 				
				Configuration::updateValue('SELECTCATPRO2_NPRODUCTS', $nbs_products);
				Configuration::updateValue('SELECTCATPRO2_ID', $ids_selected);
				
					Configuration::updateValue('SELECTCATPRO2_ROTATION', $rotation);
					
				Configuration::updateValue('SELECTCATPRO2_TITLE', $titles);
				Configuration::updateValue('SELECTCATPRO2_IDS', $idS_selected);				
				    
				return $this->displayConfirmation($this->l('The settings have been updated.'));			
			}
        }		
	}
	
	public function getContent()
	{
		return $this->postProcess().$this->renderForm();	
	}

    public function renderForm()
	{
	    $fields_form_1 = '
        <div class="cookiebanner text-center">
            '.$this->l('Have a look at my modules for PrestaShop').' -
            <a href="https://eaglemedia.de/cms.php?s=prestashop-module" target="_blank"><b>MODULE</b></a>
            <p class="clear"> </p>
            '.$this->l('Made with').' <i class="icon-heart"></i> '.$this->l('by').'
            <a href="http://eaglemedia.de" target="_blank"><b>EAGLEMEDIA</b></a>
            <p class="clear"><br/> </p>

            <form action="https://www.paypal.com/donate" method="post" target="_blank">
                <input type="hidden" name="hosted_button_id" value="ALLRFT5RZJVHN" />
                <input type="image" src="https://www.paypalobjects.com/de_DE/DE/i/btn/btn_donateCC_LG.gif" 
                       border="0" name="submit" title="PayPal - The safer, easier way to pay online!" alt="Donate with PayPal button" />

                <img alt="" border="0" src="https://www.paypal.com/de_DE/i/scr/pixel.gif" width="1" height="1" />
            </form>
            <p class="clear"><br/><br/> </p>	
        </div>';
        
		$fields_form_2 = array(
			'form' => array(
				'legend' => array(
					'title' => $this->l('Settings - Select Category Pro (2) in Tabs'),
					'icon' => 'icon-cogs'
				),
				'input' => array(
					array(
						'type' => 'text',				
						'label' => $this->l('Display quantity of products'),
						'name' => 'SELECTCATPRO2_NPRODUCTS',
						'class' => 'fixed-width-xxl',
						'desc' => $this->l('Suggestion - min quantity 6.'),
						'lang' => true,
					),
					array(
						'type' => 'text',				
						'label' => $this->l('Select ID of category'),
						'name' => 'SELECTCATPRO2_ID',
						'class' => 'fixed-width-xxl',
						'desc' => $this->l('Specify the ID of the selected category - standard ID. 4'),
						'lang' => true,
					),                    
					array(
						'type' => 'text',					
						'label' => $this->l('Tab title'),
						'name' => 'SELECTCATPRO2_TITLE',
						'class' => 'fixed-width-xxl',
						'desc' => $this->l('Specify a title for the box. Maximum 27 digits.'),
						'lang' => true,
					),
					array( 
						'type' => 'switch',
						'label' => $this->l('Randomly products'),
						'name' => 'SELECTCATPRO2_ROTATION',
						'class' => 'fixed-width-xs',						
						'values' => array(
							array(
								'id' => 'active_on',
								'value' => 1,
								'label' => $this->l('Yes')
							),
							array(
								'id' => 'active_off',
								'value' => 0,
								'label' => $this->l('No')
							)
						)						
					)					
				),
				'submit' => array(
					'title' => $this->l('Save')
				)
			),
		);
        
		$fields_form_3 = array(
			'form' => array(
				'legend' => array(
					'title' => $this->l('Override above - input your choice'),
					'icon' => 'icon-cogs'
				),
				'input' => array(
					array(
						'type' => 'text',				
						'label' => $this->l('ID\'s of products'),
						'name' => 'SELECTCATPRO2_IDS',
						'class' => 'fixed-width-xxl',
						'desc' => $this->l('If this field filled with product ids, will these products fixed in the front. Write this form \' 1, 2, 3'),
					)					
				),
				'submit' => array(
					'title' => $this->l('Save')
				)
			)
		);

		$helper = new HelperForm();
		$helper->show_toolbar = false;
		$helper->table =  $this->table;
		$lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
		$helper->default_form_language = $lang->id;
		$helper->module = $this;
		$helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;		
		$helper->identifier = $this->identifier;
		$helper->submit_action = 'submitSelectPro';
		$helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name;
		$helper->token = Tools::getAdminTokenLite('AdminModules');
		$helper->tpl_vars = array(
			'uri' => $this->getPathUri(),
			'fields_value' => $this->getConfigFieldsValues(),
			'languages' => $this->context->controller->getLanguages(),
			'id_language' => $this->context->language->id
		);

		return $fields_form_1.$helper->generateForm(array($fields_form_2)).$helper->generateForm(array($fields_form_3));
	}

	public function getConfigFieldsValues()
	{
		$languages = Language::getLanguages(false);
		$fields = array();

		foreach ($languages as $lang)
		{		
		    $fields['SELECTCATPRO2_NPRODUCTS'][$lang['id_lang']] = Tools::getValue('SELECTCATPRO2_NPRODUCTS_'.$lang['id_lang'], Configuration::get('SELECTCATPRO2_NPRODUCTS', $lang['id_lang']));
			$fields['SELECTCATPRO2_ID'][$lang['id_lang']] = Tools::getValue('SELECTCATPRO2_ID_'.$lang['id_lang'], Configuration::get('SELECTCATPRO2_ID', $lang['id_lang']));
			$fields['SELECTCATPRO2_TITLE'][$lang['id_lang']] = Tools::getValue('SELECTCATPRO2_TITLE_'.$lang['id_lang'], Configuration::get('SELECTCATPRO2_TITLE', $lang['id_lang']));			
					
			$fields['SELECTCATPRO2_ROTATION'] = Tools::getValue('SELECTCATPRO2_ROTATION', (Configuration::get('SELECTCATPRO2_ROTATION') == 1 ? '1' : '0'));			
			$fields['SELECTCATPRO2_IDS'] = Tools::getValue('SELECTCATPRO2_IDS', Configuration::get('SELECTCATPRO2_IDS'));
		}

		return $fields;
	}
	
    #
	#
	#
	#
	#	

	public function _cacheProducts()
	{   
		if (!Configuration::get('SELECTCATPRO2_IDS') AND !isset(SelectCategoryPro2::$cache_products))
		{
			$category = new Category((int)Configuration::get('SELECTCATPRO2_ID', (int)Context::getContext()->language->id),(int)Context::getContext()->language->id);			
			$nb = (int)(Configuration::get('SELECTCATPRO2_NPRODUCTS', (int)Context::getContext()->language->id));
						
			if (Configuration::get('SELECTCATPRO2_ROTATION'))
				SelectCategoryPro2::$cache_products = $category->getProducts((int)Context::getContext()->language->id, 1, ($nb ? $nb : 6), null, null, false, true, true, ($nb ? $nb : 6));
			else
				SelectCategoryPro2::$cache_products = $category->getProducts((int)Context::getContext()->language->id, 1, ($nb ? $nb : 6), 'position');
		}
		elseif (Configuration::get('SELECTCATPRO2_IDS') AND !isset(SelectCategoryPro2::$cache_products))
		{	
		    $id_lang = Context::getContext()->language->id;
			$product_pool = Configuration::get('SELECTCATPRO2_IDS');
			$product_pool = ((strpos($product_pool, ',') === false) ? (' = '.(int)$product_pool.' ') : (' IN ('.rtrim($product_pool, ',').') '));
		
			$sql = 'SELECT p.*, product_shop.*, stock.out_of_stock, IFNULL(stock.quantity, 0) as quantity, MAX(product_attribute_shop.id_product_attribute) id_product_attribute,                                                 product_attribute_shop.minimal_quantity AS product_attribute_minimal_quantity, pl.`description`, pl.`description_short`, pl.`available_now`,
						pl.`available_later`, pl.`link_rewrite`, pl.`name`, MAX(image_shop.`id_image`) id_image,
						il.`legend`, product_shop.price AS orderprice							
					FROM `'._DB_PREFIX_.'product` p
					    '.Shop::addSqlAssociation('product', 'p').'			  
					INNER JOIN `'._DB_PREFIX_.'product_lang` pl ON (
						p.`id_product` = pl.`id_product`
						AND pl.`id_lang` = '.(int)$id_lang.Shop::addSqlRestrictionOnLang('pl').'
					)
					LEFT JOIN `'._DB_PREFIX_.'product_attribute` pa	ON (p.`id_product` = pa.`id_product`)
					    '.Shop::addSqlAssociation('product_attribute', 'pa', false, 'product_attribute_shop.`default_on` = 1').'
					    '.Product::sqlStock('p', 'product_attribute_shop', false, isset($context->shop) ? $context->shop : null).'
					LEFT JOIN `'._DB_PREFIX_.'image` i ON (i.`id_product` = p.`id_product`)'.
					    Shop::addSqlAssociation('image', 'i', false, 'image_shop.cover=1').'
					LEFT JOIN `'._DB_PREFIX_.'image_lang` il ON (i.`id_image` = il.`id_image` AND il.`id_lang` = '.(int)$id_lang.')					
					WHERE p.`id_product` '.$product_pool.'					
					AND product_shop.`active` = 1
					GROUP BY product_shop.id_product';
	
			$result = Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS($sql);
			// print_r($result);
			
			if (!$result)
				return array();				
			
			/* Modify SQL result */
			SelectCategoryPro2::$cache_products = Product::getProductsProperties($id_lang, $result);
			// print_r(SelectCategoryPro2::$cache_products);
		}		
		
				
		if (SelectCategoryPro2::$cache_products === false || empty(SelectCategoryPro2::$cache_products))
			return false;
	}
	
	public function hookDisplayHeader($params)
	{
		$this->context->controller->addCSS($this->_path.'views/css/selectcategorypro2.css', 'all');
		$this->context->controller->addJS($this->_path.'views/js/selectcategorypro2.js');
	}
	// for v1.6.x
	public function hookAddProduct($params)
	{
		$this->_clearCache('*');
	}

	public function hookUpdateProduct($params)
	{
		$this->_clearCache('*');
	}

	public function hookDeleteProduct($params)
	{
		$this->_clearCache('*');
	}

	public function hookCategoryUpdate($params)
	{
		$this->_clearCache('*');
	}
    // for v1.7.x
    public function hookActionAdminGroupsControllerSaveAfter($params)
    {
        $this->_clearCache('*');
    }

	public function _clearCache($template, $cache_id = NULL, $compile_id = NULL)
	{
		parent::_clearCache('selectcategorypro-tab2.16.tpl');
        parent::_clearCache('selectcategorypro2.16.tpl');
        parent::_clearCache('selectcategorypro2.17.tpl');
	}
	
    
    // for v.1.6.x
	public function hookdisplayHomeTab($params)
	{
		if (!$this->isCached('selectcategorypro-tab2.16.tpl', $this->getCacheId('selectcategorypro-tab2.16')))
		{
			$this->_cacheProducts();			
			$this->smarty->assign(
				array(
				    'title_select' => Configuration::get('SELECTCATPRO2_TITLE', (int)Context::getContext()->language->id)
				)
			);			
		}

		return $this->display(__FILE__, 'views/templates/hook/selectcategorypro-tab2.16.tpl', $this->getCacheId('selectcategorypro-tab2.16'));
	}

	public function hookDisplayHomeTabContent($params)
	{
	    $category = new Category((int)Configuration::get('SELECTCATPRO2_ID', (int)Context::getContext()->language->id),(int)Context::getContext()->language->id);	
		
		if (!$this->isCached('selectcategorypro2.16.tpl', $this->getCacheId()))
		{
			$this->_cacheProducts();
			$this->smarty->assign(
				array(
					'products' => SelectCategoryPro2::$cache_products,					
					'homeSize' => Image::getSize(ImageType::getFormatedName('home')),
					'category_id' => Configuration::get('SELECTCATPRO2_ID', (int)Context::getContext()->language->id),
					'category_link' => $category->link_rewrite
				)
			);
		}

		return $this->display(__FILE__, 'views/templates/hook/selectcategorypro2.16.tpl', $this->getCacheId());
	}
    
    
    // for v1.7.x
	public function hookDisplayHome($params)
	{	
        if( ip2long(_PS_VERSION_) >= ip2long('1.7.0.0') )
		{
            $category = new Category((int)Configuration::get('SELECTCATPRO2_ID', (int)Context::getContext()->language->id),(int)Context::getContext()->language->id);

            if (!$this->isCached('selectcategorypro2.17.tpl', $this->getCacheId('selectcategorypro2.17.tpl')))
            {            
                $this->_cacheProducts();            
                $products = SelectCategoryPro2::$cache_products;         

                foreach($products as $key => $value) {                
                    $image_url = $this->context->link->getImageLink($value['link_rewrite'], $value['id_image'], ImageType::getFormatedName('home'));
                    $products[$key]['cover']['bySize']['home_default']['url'] = $image_url;
                    $products[$key]['url'] = $value['link'];
                    $products[$key]['price'] = Tools::displayPrice($value['price']);
                    $products[$key]['id'] = $value['id_product'];
                }  

                $this->smarty->assign(
                    array(
                        'products' => $products,	                    
                        'category_link' => Configuration::get('SELECTCATPRO2_ID', (int)Context::getContext()->language->id).'-'.$category->link_rewrite,
                        'category_link_accept' => Configuration::get('SELECTCATPRO2_IDS') ? 0 : 1
                    )
                );
            }

            return $this->display(__FILE__, 'views/templates/hook/selectcategorypro2.17.tpl', $this->getCacheId('selectcategorypro2.17.tpl'));
        }
    }    
    
 	public function hookDisplayCrossSellingShoppingCart($params)
	{   
        return $this->hookDisplayHome($params);
    }    

    public function hookDisplayOrderConfirmation2($params)
	{   
        return $this->hookDisplayHome($params);
    }
    
    public function hookDisplayReassurance($params)
	{   
        return $this->hookDisplayHome($params);
    }
    
    
    public function hookDisplayFooterProduct($params)
	{   
		$category = new Category((int)Configuration::get('SELECTCATPRO2_ID', (int)Context::getContext()->language->id),(int)Context::getContext()->language->id);
        
		if (!$this->isCached('selectcategorypro-product2.17.tpl', $this->getCacheId('selectcategorypro-product2.17.tpl')))
		{            
			$this->_cacheProducts();            
            $products = SelectCategoryPro2::$cache_products;         
                
            foreach($products as $key => $value) {                
                $image_url = $this->context->link->getImageLink($value['link_rewrite'], $value['id_image'], ImageType::getFormatedName('home'));
                $products[$key]['cover']['bySize']['home_default']['url'] = $image_url;
                $products[$key]['url'] = $value['link'];
                $products[$key]['price'] = Tools::displayPrice($value['price']);
                $products[$key]['id'] = $value['id_product'];
            }  
        
			$this->smarty->assign(
				array(
					'products' => $products,	                    
					'category_link' => Configuration::get('SELECTCATPRO2_ID', (int)Context::getContext()->language->id).'-'.$category->link_rewrite,
                    'category_link_accept' => Configuration::get('SELECTCATPRO2_IDS') ? 0 : 1
				)
			);
		}

		return $this->display(__FILE__, 'views/templates/hook/selectcategorypro-product2.17.tpl', $this->getCacheId('selectcategorypro-product2.17.tpl'));
    }
}
